<?php
/**
 * Comments controller class
 */
class Comments extends Unit
{
	/**
	 * Overloaded constructor
	 */
	public function __construct()
	{
		global $Users, $Entries;
		parent::__construct('comments', 'Comment', 'golb_', 'com_', array(
			'id' => new Param(Param_type::int, 'id', FALSE, FALSE, TRUE),
			'golb' => new Reference('golb', $Entries, 'name', TRUE, TRUE),
			'user' => new Reference('user', $Users, 'name', FALSE),
			'text' => new Bbtext('text', TRUE, TRUE)
		));
	}
}

/**
 * Overloaded comment item class
 */
class Comment extends Item
{
	/**
	 * A simplified constructor which may be called with 1 parameter
	 */
	public function __construct($unit = NULL, $source = NULL)
	{
		global $Comments;
		if (is_null($source))
		{
			$source = $unit;
			$unit = $Comments;
		}
		parent::__construct($unit, $source);
	}

	/**
	 * Overloaded import to set some default values
	 * @param string $method Form method
	 * @param string $prefix Param prefix
	 * @return mixed
	 */
	public function import($method = 'P', $prefix = NULL)
	{
		global $usr;
		$this->entity['user']->default = $usr['id'];
		$golb = sed_import('golb', 'G', 'INT');
		if ($golb > 0) $this->entity['golb']->default = $golb;
		return parent::import($method, $prefix);
	}
}
?>
