<?php
/**
 * Comments controller class
 */
class Entries extends Unit
{
	/**
	 * Overloaded constructor
	 */
	public function __construct()
	{
		global $Users;
		parent::__construct('entries', 'Entry', 'golb_', 'ent_', array(
			'id' => new Param(Param_type::int, 'id', FALSE, FALSE, TRUE),
			'user' => new Reference('user', $Users, 'name', FALSE),
			'date' => new DateTimeStamp('date', FALSE),
			'name' => new Param(Param_type::string, 'name', TRUE, TRUE),
			'text' => new Bbtext('text', TRUE, TRUE)
		));
	}
}

/**
 * Overloaded comment item class
 */
class Entry extends Item
{
	/**
	 * A simplified constructor which may be called with 1 parameter
	 */
	public function __construct($unit = NULL, $source = NULL)
	{
		global $Entries;
		if (is_null($source))
		{
			$source = $unit;
			$unit = $Entries;
		}
		parent::__construct($unit, $source);
	}

	/**
	 * Overloaded import to set some default values
	 * @param string $method Form method
	 * @param string $prefix Param prefix
	 * @return mixed
	 */
	public function import($method = 'P', $prefix = NULL)
	{
		global $usr;
		$this->entity['user']->default = $usr['id'];
		$this->entity['date']->default = time();
		return parent::import($method, $prefix);
	}

	/**
	 * Overloaded entry display to show comments
	 */
	public function display_auto($tpl, $block, $row_block = 'PARAM', $title_tag = 'PARAM_TITLE', $value_tag = 'PARAM_VALUE')
	{
		global $L, $pl, $Comments, $cfg, $id, $t;
		$t2 = new XTemplate($cfg['plugins_dir'] . '/golb/tpl/comments.tpl');
		$t2->assign(array(
			'ADD_URL' => sed_url('plug', "e={$pl['pl_code']}&z=comments&m=add&golb=$id")
		));
		$Comments->display_list($t2, 'MAIN', ' com_golb = ' . $id);
		$t2->parse('MAIN');
		$tpl->assign('COMMENTS', $t2->text('MAIN'));
		parent::display_auto($tpl, $block, $row_block, $title_tag, $value_tag);
	}
}

?>
