<?php
/**
 * @package CCL
 * @version 0.0.1
 * @author trustmaster
 * @copyright (c) 2009 Vladimir Sibirov
 * @license BSD
 */

/**
 * Text area with bbcode parser support and editor
 * @todo Add HTML-cache support for Bbtext fields
 */
class Bbtext extends Textarea {
	/**
	 * Renders param value display in a correct way
	 * @param mixed $value
	 * @return string Rendered display element
	 * @see Bbtext::display_input(), Param::title, Param::hint
	 */
	public function display($value)
	{
		return sed_bbcode_parse($value);
	}
	/**
	 * Renders param input display in a correct way
	 * @param mixed $value
	 * @param string $prefix Input name prefix
	 * @return string
	 * @see Param::title, Param::hint
	 */
	public function display_input($value = NULL, $prefix = '')
	{
		if (is_null($value) && !is_null($this->default))
		{
			$value = $this->default;
		}
		$class = empty($this->input_class) ? ' class="editor"' : ' class="' . $this->input_class . ' editor"';
		$rows = is_null($this->rows) ? '' : ' rows="' . (int) $this->rows . '"';
		$cols = is_null($this->cols) ? '' : ' cols="' . (int) $this->cols . '"';
		$value = is_null($value) ? '' : sed_cc($value);
		$disp = '<textarea name="' . $prefix . $this->name . '"'. $rows . $cols . $class .'>' . $value . '</textarea>';
		return $disp;
	}
}
?>
