<?php
/**
 * Cotonti Class Library - rich Model-View-Controller module development
 * and business logic framework for Cotonti CMF
 *
 * @package CCL
 * @version 0.0.1
 * @author trustmaster
 * @copyright (c) 2009 Vladimir Sibirov
 * @license BSD
 */

$cfg['modules_dir'] = './modules';

/**
 * Automatically loads required classes and interfaces on demand
 *
 * @global array $cfg Cotonti configuration
 * @param string $name Class or interface name
 */
function __autoload($name)
{
	global $cfg, $pl;

	if (file_exists($cfg['system_dir'] . "/ccl/$name.php"))
	{
		$path = $cfg['system_dir'] . "/ccl/$name.php";
	}
	elseif (defined(SED_MODULE))
	{
		$path = $cfg['modules_dir'] . '/' . SED_MODULE . "/classes/$name.php";
	}
	else
	{
		$path = $cfg['plugins_dir'] . '/' . $pl['pl_code'] . "/classes/$name.php";
	}
	
	if(file_exists($path))
	{
		require_once $path;
	}
	else
	{
		die("Class $name not found in $path");
	}
}

/**
 * Gets skin path for a module
 * @param string $action Action or template name
 * @param string $class Unit name
 * @param bool $relation Search for relation skinfile
 * @return string
 */
function mod_skinfile($action, $class = 'auto', $relation = FALSE)
{
	global $cfg, $pl;
	
	if (!defined(SED_MODULE)) return $cfg['plugins_dir'] . '/' . $pl['pl_code'] . "/tpl/$action.tpl";

	$class = mb_strtolower($class);
	if(file_exists($cfg['modules_dir'] . '/' . SED_MODULE. '/tpl/' . $class . '.' . $action . '.tpl'))
	{
		$tpl = $cfg['modules_dir'] . '/' . SED_MODULE. '/tpl/' . $class . '.' . $action . '.tpl';
	}
	else
	{
		if ($relation && file_exists($cfg['modules_dir'] . '/' . SED_MODULE. '/tpl/relation.' . $action . '.tpl'))
		{
			$tpl = $cfg['modules_dir'] . '/' . SED_MODULE. '/tpl/relation.' . $action . '.tpl';
		}
		else
		{
			$tpl = $cfg['modules_dir'] . '/' . SED_MODULE. '/tpl/' . $action . '.tpl';
		}
	}
	return $tpl;
}
?>
