<?php
/**
 * @package CCL
 * @version 0.0.1
 * @author trustmaster
 * @copyright (c) 2009 Vladimir Sibirov
 * @license BSD
 */

/**
 * Link is a relation that links Units with each other
 */
class Relation extends Unit {
	/**
	 * Initializes Relation entity
	 * @param string $name Unit name
	 * @param string $item_class Name of the Item class representing objects for this Unit
	 * @param string $prefix Table prefix
	 * @param string $col_prefix Column prefix
	 * @param array $params Array of Param objects
	 */
	public function __construct($name, $item_class = 'Link', $prefix = '', $col_prefix = '', $params = NULL)
	{
		parent::__construct($name, $item_class, $prefix, $col_prefix);
		if (is_array($params))
		{
			$primary_key = join(',', array_keys($params));
			$this->define($params, $primary_key);
		}
	}

	/**
	 * Fetches rowset of target items referenced with source item. For binary relations
	 * @param string $source Source parameter name
	 * @param int $source_id Source item identifier
	 * @param string $target Target parameter name
	 */
	/*public static function get_referenced_items($source, $source_id, $target)
	{
		$target_table = $this->data[$target]->entity->table_name;
		$target_key = $this->data[$target]->entity->col_prefix . $this->data[$target]->entity->primary_key;
		$res = sed_sql_query("SELECT t.* FROM `".$this->table_name."` AS s
			LEFT JOIN `$target_table` AS t ON s.`$target` = t.`$target_key`
			WHERE s.`$source` = $source_id");
		while ($rowset[] = sed_sql_fetchassoc($res));
		sed_sql_freeresult($res);
		return $rowset;
	}*/

	/**
	 * Unit main overloaded
	 */
	public function main()
	{
		global $m, $id, $id_str;
		if ($m == 'display' || $m == 'edit' || $m == 'remove')
		{
			// Get complex ID
			$id = array();
			$id_str = '';
			foreach ($this->data as $name => $val)
			{
				$id[$name] = sed_import($name, 'G', 'INT');
				$id_str .= "&$name=" . $id[$name];
			}
		}
		parent::main();
	}
}
?>
