<?php
/**
 * @package CCL
 * @version 0.0.1
 * @author trustmaster
 * @copyright (c) 2009 Vladimir Sibirov
 * @license BSD
 */

/**
 * Message text parameter class
 */
class Textarea extends Param {
	/**
	 * @var int Textarea rows 
	 */
	public $rows = NULL;
	/**
	 * @var int Textarea columns
	 */
	public $cols = NULL;

    /**
	 * Parameter constructor
	 * @param string $name Parameter name
	 * @param bool $display Render it in templates
	 * @param bool $required Require it from user input
	 */
	public function __construct($name, $display = TRUE, $required = FALSE)
	{
		parent::__construct(Param_type::string, $name, $display, $required);
		$this->allow_html = TRUE;
	}

	/**
	 * Renders param input display in a correct way
	 * @param mixed $value
	 * @param string $prefix Input name prefix
	 * @return string
	 * @see Param::title, Param::hint
	 */
	public function display_input($value = NULL, $prefix = '')
	{
		if (is_null($value) && !is_null($this->default))
		{
			$value = $this->default;
		}
		$class = empty($this->input_class) ? '' : ' class="' . $this->input_class . '"';
		$rows = is_null($this->rows) ? '' : ' rows="' . (int) $this->rows . '"';
		$cols = is_null($this->cols) ? '' : ' cols="' . (int) $this->cols . '"';
		$value = is_null($value) ? '' : sed_cc($value);
		$disp = '<textarea name="' . $prefix . $this->name . '"'. $rows . $cols . $class .'>' . $value . '</textarea>';
		return $disp;
	}
}
?>
